var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};const React = require('react');
const { FormattedMessage } = require('react-intl');
const PropTypes = require('prop-types');
const cx = require('classnames');

class TagList extends React.PureComponent {
	renderTag(index) {
		const { tags } = this.props;
		const tag = index < tags.length ?
		tags[index] : {
			tag: "" };

		const { onDragOver, onDragExit, onDrop } = this.props.dragObserver;

		const className = cx('tag-selector-item', 'zotero-clicky', {
			selected: tag.selected,
			colored: tag.color,
			disabled: tag.disabled });


		let props = {
			className,
			onClick: ev => !tag.disabled && this.props.onSelect(tag.name, ev),
			onContextMenu: ev => this.props.onTagContext(tag, ev),
			onDragOver,
			onDragExit,
			onDrop };


		if (tag.color) {
			props['style'] = {
				color: tag.color };

		}


		return (
			React.createElement('li', _extends({ key: index }, props),
				tag.name));


	}

	render() {
		const totalTagCount = this.props.tags.length;
		var tagList =
		React.createElement('ul', { className: 'tag-selector-list' },

			[...Array(totalTagCount).keys()].map(index => this.renderTag(index)));



		if (!this.props.loaded) {
			tagList =
			React.createElement('div', { className: 'tag-selector-message' },
				React.createElement(FormattedMessage, { id: 'zotero.tagSelector.loadingTags' }));


		} else if (totalTagCount == 0) {
			tagList =
			React.createElement('div', { className: 'tag-selector-message' },
				React.createElement(FormattedMessage, { id: 'zotero.tagSelector.noTagsToDisplay' }));


		}
		return (
			React.createElement('div', {
					className: 'tag-selector-container',
					ref: ref => {this.container = ref;} },
				tagList));



	}}


module.exports = TagList;